$(function(){
DevExpress.setTemplateEngine("underscore");
var listData = [
{
data: new DevExpress.data.DataSource({
store: contacts,
sort: "name"
})
}, {
data: new DevExpress.data.DataSource({
store: contacts,
sort: "name",
filter: ["category", "=", "Missed"]
})
}, {
data: new DevExpress.data.DataSource({
store: contacts,
sort: "name",
filter: ["category", "=", "Favorites"]
})
}
];
var list = $("#list").dxList({
dataSource: listData[0].data,
itemTemplate: $("#item-template")
}).dxList("instance");
$("#navbar").dxNavBar({
dataSource: navData,
selectedIndex: 0,
onItemClick: function(e) {
list.option("dataSource", listData[e.itemIndex].data);
}
});
});
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
<script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script>
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/20.2.5/css/dx.common.css" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/20.2.5/css/dx.light.css" />
<script src="https://cdn3.devexpress.com/jslib/20.2.5/js/dx.all.js"></script>
<script src="js/underscore.js"></script>
<script src="data.js"></script>
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="index.js"></script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="list"></div>
<div id="navbar"></div>
<script type="text/html" id="item-template">
<div class="image-container">
<img src="<%= image %>">
</div>
<div class="info">
<div><%= name %></div>
<div><%= phone %></div>
<div><%= email %></div>
</div>
</div>
</script>
</div>
</body>
</html>
.dx-list {
height: 90%;
position: absolute;
top: 0;
bottom: 0;
}
.info {
margin-top: 5px;
height: 78px;
}
.image-container {
width: 65px;
float: left;
margin-right: 20px;
}
.image-container img {
display: block;
width: 100%;
}
.dx-tabs.dx-navbar {
text-align: center;
position: absolute;
bottom: 0;
}
var contacts = [
{ name: "Barbara J. Coggins", phone: "512-964-2757", image: "../../../../images/employees/04.png", email: "BarbaraJCoggins@rhyta.com", category: "Favorites" },
{ name: "Leslie S. Alcantara", phone: "360-684-1334", image: "../../../../images/employees/01.png", email: "LeslieSAlcantara@teleworm.us", category: "Missed" },
{ name: "Chad S. Miles", phone: "520-573-7903", image: "../../../../images/employees/02.png", email: "ChadSMiles@rhyta.com", category: "Favorites" },
{ name: "Michael A. Blevins", phone: "530-480-1961", image: "../../../../images/employees/03.png", email: "MichaelABlevins@armyspy.com", category: "Missed" },
{ name: "Jane K. Hernandez", phone: "404-781-0805", image: "../../../../images/employees/05.png", email: "JaneKHernandez@teleworm.us", category: "Favorites" },
{ name: "Kim D. Thomas", phone: "603-583-9043", image: "../../../../images/employees/06.png", email: "KimDThomas@teleworm.us", category: "Outgoing call" },
{ name: "Donald L. Jordan", phone: "772-766-2842", image: "../../../../images/employees/07.png", email: "DonaldLJordan@dayrep.com", category: "Favorites" },
{ name: "Nicole A. Rios", phone: "213-812-8400", image: "../../../../images/employees/09.png", email: "NicoleARios@armyspy.com", category: "Missed" },
{ name: "Barbara M. Roberts", phone: "614-365-7945", image: "../../../../images/employees/08.png", email: "BarbaraMRoberts@armyspy.com", category: "Outgoing call" }
];
var navData = [{
text: "Contacts",
icon: "user"
}, {
text: "Missed",
icon: "clock",
badge: 3
}, {
text: "Favorites",
icon: "favorites"
}
];

<dx-list [dataSource]="currentData">
<div *dxTemplate="let item of 'item'">
<div class="image-container">
<img src="{{item.image}}">
</div>
<div class="info">
<div>{{item.name}}</div>
<div>{{item.phone}}</div>
<div>{{item.email}}</div>
</div>
</div>
</dx-list>
<dx-nav-bar
[dataSource]="navBarData"
(onItemClick)="selectionChanged($event)"
[selectedIndex]="0"
></dx-nav-bar>
import { NgModule, Component, enableProdMode } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { DxListModule, DxNavBarModule, DxTemplateModule } from 'devextreme-angular';
import DataSource from 'devextreme/data/data_source';
import { Category, Service } from './app.service';
if(!/localhost/.test(document.location.host)) {
enableProdMode();
}
@Component({
selector: 'demo-app',
templateUrl: 'app/app.component.html',
styleUrls: ['app/app.component.css'],
providers: [Service]
})
export class AppComponent {
navBarData: Category[];
listData: any[];
currentData: any;
constructor(service: Service) {
let contacts = service.getContacts();
this.navBarData = service.getCategories();
this.listData = [
{
data: new DataSource({
store: contacts,
sort: "name"
})
}, {
data: new DataSource({
store: contacts,
sort: "name",
filter: ["category", "=", "Missed"]
})
}, {
data: new DataSource({
store: contacts,
sort: "name",
filter: ["category", "=", "Favorites"]
})
}
];
this.currentData = this.listData[0].data;
}
selectionChanged(e) {
this.currentData = this.listData[e.itemIndex].data;
}
}
@NgModule({
imports: [
BrowserModule,
DxListModule,
DxNavBarModule,
DxTemplateModule
],
declarations: [AppComponent],
bootstrap: [AppComponent]
})
export class AppModule { }
platformBrowserDynamic().bootstrapModule(AppModule);
::ng-deep .dx-list {
height: 90%;
position: absolute;
top: 0;
bottom: 0;
}
::ng-deep .info {
margin-top: 5px;
height: 78px;
}
::ng-deep .image-container {
width: 65px;
float: left;
margin-right: 20px;
}
::ng-deep .image-container img {
display: block;
width: 100%;
}
::ng-deep .dx-tabs.dx-navbar {
text-align: center;
position: absolute;
bottom: 0;
}
import { Injectable } from '@angular/core';
export class Contact {
name: string;
phone: string;
image: string;
email: string;
category: string;
}
export class Category {
text: string;
icon: string;
badge?: number;
}
let contacts: Contact[] = [
{ name: "Barbara J. Coggins", phone: "512-964-2757", image: "../../../../images/employees/04.png", email: "BarbaraJCoggins@rhyta.com", category: "Favorites" },
{ name: "Leslie S. Alcantara", phone: "360-684-1334", image: "../../../../images/employees/01.png", email: "LeslieSAlcantara@teleworm.us", category: "Missed" },
{ name: "Chad S. Miles", phone: "520-573-7903", image: "../../../../images/employees/02.png", email: "ChadSMiles@rhyta.com", category: "Favorites" },
{ name: "Michael A. Blevins", phone: "530-480-1961", image: "../../../../images/employees/03.png", email: "MichaelABlevins@armyspy.com", category: "Missed" },
{ name: "Jane K. Hernandez", phone: "404-781-0805", image: "../../../../images/employees/05.png", email: "JaneKHernandez@teleworm.us", category: "Favorites" },
{ name: "Kim D. Thomas", phone: "603-583-9043", image: "../../../../images/employees/06.png", email: "KimDThomas@teleworm.us", category: "Outgoing call" },
{ name: "Donald L. Jordan", phone: "772-766-2842", image: "../../../../images/employees/07.png", email: "DonaldLJordan@dayrep.com", category: "Favorites" },
{ name: "Nicole A. Rios", phone: "213-812-8400", image: "../../../../images/employees/09.png", email: "NicoleARios@armyspy.com", category: "Missed" },
{ name: "Barbara M. Roberts", phone: "614-365-7945", image: "../../../../images/employees/08.png", email: "BarbaraMRoberts@armyspy.com", category: "Outgoing call" }
];
let categories: Category[] = [
{
text: "Contacts",
icon: "user"
}, {
text: "Missed",
icon: "clock",
badge: 3
}, {
text: "Favorites",
icon: "favorites"
}
];
@Injectable()
export class Service {
getContacts(): Contact[] {
return contacts;
}
getCategories(): Category[] {
return categories;
}
}
// In real applications, you should not transpile code in the browser. You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
System.config({
transpiler: 'ts',
typescriptOptions: {
module: "system",
emitDecoratorMetadata: true,
experimentalDecorators: true
},
meta: {
'typescript': {
"exports": "ts"
},
'devextreme/localization.js': {
"esModule": true
}
},
paths: {
'npm:': 'https://unpkg.com/'
},
map: {
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@3.5.3/lib/typescript.js',
'@angular': 'npm:@angular',
'tslib': 'npm:tslib@2.1.0/tslib.js',
'rxjs': 'npm:rxjs@6.4.0',
'rrule': 'npm:rrule@2.6.6/dist/es5/rrule.js',
'luxon': 'npm:luxon@1.25.0/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign@1.1.0',
'devextreme': 'npm:devextreme@20.2.5',
'jszip': 'npm:jszip@3.5.0/dist/jszip.min.js',
'devextreme-quill': 'npm:devextreme-quill@0.9.8/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.0.11',
'devexpress-gantt': 'npm:devexpress-gantt@2.0.18',
'devextreme-angular': 'npm:devextreme-angular@20.2.5',
'preact': 'npm:preact@10.5.11/dist/preact.js',
'preact/hooks': 'npm:preact@10.5.11/hooks/dist/hooks.js'
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts'
},
'devextreme': {
defaultExtension: 'js'
},
'devextreme/events/utils': {
main: 'index'
},
'devextreme/events': {
main: 'index'
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js'
}
},
packageConfigPaths: [
"npm:@angular/*/package.json",
"npm:@angular/common/*/package.json",
"npm:rxjs/package.json",
"npm:rxjs/operators/package.json",
"npm:devextreme-angular/*/package.json",
"npm:devextreme-angular/ui/*/package.json",
"npm:devextreme-angular/package.json",
"npm:devexpress-diagram/package.json",
"npm:devexpress-gantt/package.json",
]
});
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/20.2.5/css/dx.common.css" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/20.2.5/css/dx.light.css" />
<script src="https://unpkg.com/core-js@2.4.1/client/shim.min.js"></script>
<script src="https://unpkg.com/zone.js@0.10.2/dist/zone.js"></script>
<script src="https://unpkg.com/reflect-metadata@0.1.3/Reflect.js"></script>
<script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import('app').catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>